export class ModalProxy
{
    #modalInstance = null;
    #modalElement = null;
    #modalFunctionRef = {
        open: 'show',
        close: 'hide',
        toggle: 'toggle'
    }

    constructor(element, instance, options)
    {
        this.#modalElement = element;
        this.#modalInstance = instance;
        Object.assign(this.#modalFunctionRef, options)
    }

    get element()
    {
        return this.#modalElement;
    }

    get instance()
    {
        return this.#modalInstance;
    }

    open()
    {
        return this.#modalInstance[this.#modalFunctionRef.open]();
    }

    close()
    {
        return this.#modalInstance[this.#modalFunctionRef.close]();
    }

    toggle()
    {
        return this.#modalInstance[this.#modalFunctionRef.toggle]();
    }
}
